// SLogFile.cpp: Implementierung der Klasse SLogFile.
//
// Copyright by Andr Stein
// E-Mail: stonemaster@steinsoft.net, andre_stein@web.de
// http://www.steinsoft.net
//////////////////////////////////////////////////////////////////////

#include "SLogFile.h"

#include <fstream.h>
#include <string.h>


#define SAFE_DELETE_ARRAY(a) if(a){delete[] a;a=NULL;}

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

SLogFile::SLogFile()
{
	filename = NULL;
}

SLogFile::~SLogFile()
{
	SAFE_DELETE_ARRAY(filename);
}

SLogFile::SLogFile(char *logfile, bool append)
{
	filename = NULL;
	open(logfile,append);
}

///////////////////////////////////////////////////////////////////////
// Funktionen
///////////////////////////////////////////////////////////////////////

void SLogFile::open(char *logfile, bool append)
{
	SAFE_DELETE_ARRAY(filename)
		
	int stringLength = strlen(logfile);

	filename = new char[stringLength + 1];

	for (int i = 0; i < stringLength; i += 1)
	{
		filename[i] = logfile[i];
	}

	filename[stringLength] = '\0';

	if (!append)
	{
		ofstream file;
		
		file.open(filename,ios::out | ios::trunc);
		
		file.close();
	}
}

void SLogFile::writeLine(char *buffer)
{
	ofstream file;
	
	if (!filename || !buffer)
	{
		return;
	}

	try
	{
		file.open(filename,ios::out | ios::app);
		file << buffer << "\r\n" << flush;
		file.close();
	}
	catch(...)
	{

	}
}

void SLogFile::operator << (char *buffer)
{
	writeLine(buffer);
}
